/*
	X^bN̎
*/

#include <stdio.h>
#include <stdlib.h>

/*--- X^bN\ ---*/
typedef struct {
	int max;		/* X^bN̗e */
	int ptr;		/* X^bN|C^ */
	int *stk;		/* X^bN{́i擪vfւ̃|C^j*/
} Stack;

/*--- X^bN̏E ---*/
int StackAlloc(Stack *s, int max)
{
	s->ptr = 0;
	if ((s->stk = calloc(max, sizeof(int))) == NULL) {	/* z̊mۂɎs */
		s->max = 0;
		return -1;
	}
	s->max = max;
	return 0;
}

/*--- X^bŇn ---*/
void StackFree(Stack *s)
{
	if (s->stk != NULL) {			/* X^bNĂ */
		free(s->stk);				/* z */
		s->max = s->ptr = 0;
	}
}

/*--- X^bNɃf[^vbV ---*/
int StackPush(Stack *s, int x)
{
	if (s->ptr >= s->max)					/* X^bNt */
		 return -1;
	s->stk[s->ptr++] = x;
	return 0;
}

/*--- X^bNf[^|bv ---*/
int StackPop(Stack *s, int *x)
{
	if (s->ptr <= 0)						/* X^bN */
		return -1;
	*x = s->stk[--s->ptr];
	return 0;
}

/*--- X^bNf[^s[N ---*/
int StackPeek(const Stack *s, int *x)
{
	if (s->ptr <= 0)						/* X^bN */
		return -1;
	*x = s->stk[s->ptr - 1];
	return 0;
}

/*--- X^bN̗e ---*/
int StackSize(const Stack *s)
{
	return s->max;
}

/*--- X^bNɐς܂Ăf[^ ---*/
int StackNo(const Stack *s)
{
	return s->ptr;
}

/*--- X^bN͋ ---*/
int StackIsEmpty(const Stack *s)
{
	return s->ptr <= 0;
}

/*--- X^bN͖t ---*/
int StackIsFull(const Stack *s)
{
	return s->ptr >= s->max;
}

/*--- X^bNɂ ---*/
void StackClear(Stack *s)
{
	s->ptr = 0;
}

int main(void)
{
	Stack stk;

	if (StackAlloc(&stk, 100) == -1) {
		puts("X^bN̊mۂɎs܂B");
		return 1;
	}
	while (1) {
		int m, x;

		printf("݂̃f[^F%d/%d\n", StackNo(&stk), StackSize(&stk));
		printf("(1) vbV  (2) |bv@(0) IF");
		scanf("%d", &m);
		if (m == 0) break;

		switch (m) {
		 case 1: printf("f[^F");  scanf("%d", &x);
				 if (StackPush(&stk, x) == -1)
					puts("vbVł܂B");
				 break;

		 case 2: if (StackPop(&stk, &x) == -1)
					puts("|bvł܂B");
				 else
					printf("|bvf[^%dłB\n", x);
				 break;
		}
	}
	StackFree(&stk);

	return 0;
}
