/*
	zɂ`Xg̎
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define Null  -1			/* CfbNX */

typedef enum {
	Term, Insert, Append, Delete, Print, Clear
} Menu;

typedef int  Index;			/* CfbNX^ */

/*--- m[h ---*/
typedef struct {
	int   no;			/* ԍ */
	char  name[10];		/* O */
	Index next;			/* 㑱vf̃CfbNX */
	Index Dnext;		/* 폜Xg|C^ */
} Node;

/*--- `Xg ---*/
typedef struct {
	Node  *n;			/* Xg{́izj */
	Index top;			/* Xg̐擪vf̃CfbNX */
	Index max;			/* pR[h̍őCfbNX */
	Index deleted;		/* 폜Xg̐擪vf̃CfbNX */
} List;

#define Top     (list->top)				/* Xg̐擪 */

#define Second  (list->n[Top].next)		/* XĝQԖ */

#define Next(x) (list->n[(x)].next)		/* R[hx̌㑱vf */

/*--- m[h̊eoɒlݒ ----*/
void SetNode(Node *x, int no, const char *name, Index next)
{
	x->no	= no;
	x->next = next;
	strcpy(x->name, name);
}

/*--- }ׂR[h̃CfbNXԂ ---*/
int GetIndex(List *list)
{
	if (list->deleted == Null)			/* 폜R[hȂꍇ */
		return ++(list->max);
	else {
		Index rec = list->deleted;
		list->deleted = list->n[rec].Dnext;
		return rec;
	}
}

/*--- w肵R[h폜Xgɓo^ ---*/
void DeleteIndex(List *list, Index idx)
{
	if (list->deleted == Null) {		/* 폜R[hȂꍇ */
		list->deleted = idx;
		list->n[idx].Dnext = Null;
	} else {
		Index ptr = list->deleted;
		list->deleted = idx;
		list->n[idx].Dnext = ptr;
	}
}

/*--- 擪Ƀm[h} ---*/
void InsertNode(List *list, int no, const char *name)
{
	Index ptr = Top;
	Top = GetIndex(list);
	SetNode(&list->n[Top], no, name, ptr);
}

/*--- Ƀm[hǉ ---*/
void AppendNode(List *list, int no, const char *name)
{
	if (Top == Null)						/* Xgł */
		InsertNode(list, no, name);			/* 擪ɑ} */
	else {
		Index ptr = Top;
		while (Next(ptr) != Null)			/* m[h */
			ptr = Next(ptr);
		Next(ptr) = GetIndex(list);
		SetNode(&list->n[Next(ptr)], no, name, Null);
	}
}

/*--- 擪m[h폜 ---*/
void DeleteNode(List *list)
{
	if (Top != Null) {						/* XgłȂ */
		Index ptr = Second;
		DeleteIndex(list, Top);
		Top = ptr;
	}
}

/*--- ׂẴm[h폜 ---*/
void ClearList(List *list)
{
	while (Top != Null)					/* XgɂȂ܂ */
		DeleteNode(list);				/* 擪m[h폜 */
}

/*--- ׂẴm[h\ ---*/
void PrintList(List *list)
{
	Index ptr = Top;

	puts("yꗗ\z");
	while (ptr != Null) {
		printf("%5d %-10.10s\n", list->n[ptr].no, list->n[ptr].name);
		ptr = Next(ptr);
	}
}

/*--- `Xg̏ ---*/
void InitList(List *list, int size)
{
	/* vf^Nodeŗvfsize̔zxɊm */
	list->n = calloc(size, sizeof(Node));
	list->top = list->max = list->deleted = Null;
}

/*--- `Xǧn ---*/
void TermList(List *list)
{
	ClearList(list);				/* ׂẴm[h폜 */
	free(list->n);
}

/*--- f[^̓ ---*/
Node Read(const char *message)
{
	Node temp;

	printf("%sf[^͂ĂB\n", message);

	printf("ԍF");	scanf("%d", &temp.no);
	printf("OF");	scanf("%s", temp.name);

	return temp;
}

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("\n(1) 擪Ƀm[h}   (2) Ƀm[hǉ\n");
		printf("(3) 擪̃m[h폜   (4) Sm[h\\n");
		printf("(5) Sm[h폜       (0)        I    F ");
		scanf("%d", &ch);
	} while (ch < Term || ch > Clear);
	return (Menu)ch;
}

/*--- C ---*/
int main(void)
{
	Menu menu;
	List list;

	InitList(&list, 100);		/* őm[h100 */

	do {
		Node x;
		switch (menu = SelectMenu()) {
		 case Insert: x = Read("擪ɑ}");
					  InsertNode(&list, x.no, x.name);
					  break;
		 case Append: x = Read("ɒǉ");
					  AppendNode(&list, x.no, x.name);
					  break;
		 case Delete: DeleteNode(&list);
					  break;
		 case Print : PrintList(&list);
					  break;
		 case Clear : ClearList(&list);
					  break;
		}
	} while (menu != Term);

	TermList(&list);			/* `Xg̗pI */

	return 0;
}
